using System;
using System.Collections;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Web;
using System.Web.SessionState;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.HtmlControls;

namespace FocusStyle
{
	/// <summary>
	/// Summary description for WebForm1.
	/// </summary>
	public class WebForm1 : System.Web.UI.Page
	{
		protected System.Web.UI.WebControls.Label Label1;
		protected System.Web.UI.WebControls.Label Label2;
		protected System.Web.UI.WebControls.Label Label3;
		protected System.Web.UI.WebControls.Label Label6;
		protected System.Web.UI.WebControls.Label Label7;
		protected System.Web.UI.WebControls.Button Button1;
		protected System.Web.UI.WebControls.Button Button2;
		protected System.Web.UI.WebControls.TextBox TextBox2;
		protected System.Web.UI.WebControls.TextBox TextBox1;
		protected System.Web.UI.WebControls.DropDownList DropDownList1;
		protected System.Web.UI.WebControls.Label Label4;
		protected System.Web.UI.WebControls.ListBox ListBox1;
		protected System.Web.UI.WebControls.TextBox TextBox3;
	
		private void Page_Load(object sender, System.EventArgs e)
		{
			SetAllInputControlsColors(this, SystemColors.Window, SystemColors.WindowText, Color.Yellow, Color.Blue);

			// un-comment the next line to use the CSS approach
			SetAllInputControlsClassName(this, "", "ActiveTextBox");
		}


		// Change the backgroundColor and color attributes of the specified control
		void SetInputControlColors(WebControl ctl, Color backColor, Color foreColor, Color focusBackColor,  Color focusForeColor)
		{
			string jsOnFocus = string.Format(
				"this.style.backgroundColor = '{0}'; this.style.color = '{1}';", 
				focusBackColor.Name, focusForeColor.Name);

			string jsOnBlur = string.Format(
				"this.style.backgroundColor = '{0}'; this.style.color = '{1}';", 
				backColor.Name, foreColor.Name);

			ctl.Attributes.Add("onfocus", jsOnFocus);
			ctl.Attributes.Add("onblur", jsOnBlur);
		}

		// Change the backgroundColor and color attributes of all the specified control's child input controls
		void SetAllInputControlsColors(Control parent, Color backColor, Color foreColor, Color focusBackColor,  Color focusForeColor)
		{
			foreach (Control ctl in parent.Controls)
			{
				if (ctl is TextBox || ctl is ListBox || ctl is DropDownList)
				{
					SetInputControlColors(ctl as WebControl, 
						backColor, foreColor, focusBackColor, focusForeColor);
				}
				else
				{
					SetAllInputControlsColors(ctl, 
						backColor, foreColor, focusBackColor, focusForeColor);
				}
			}
		}


		// Change the CSS class of the specified control
		void SetInputControlClassName(WebControl ctl, string className, string focusClassName)
		{
			string jsOnFocus = String.Format("this.className = '{0}';", focusClassName);

			string jsOnBlur = String.Format("this.className = '{0}';", className);

			ctl.Attributes.Add("onfocus", jsOnFocus);
			ctl.Attributes.Add("onblur", jsOnBlur);
		}

		// Change the CSS class of all the specified control's child input controls
		void SetAllInputControlsClassName(Control parent, string className, string focusClassName)
		{
			foreach (Control ctl in parent.Controls)
			{
				if (ctl is TextBox || ctl is ListBox || ctl is DropDownList)
					SetInputControlClassName(ctl as WebControl, className, focusClassName);
				else
					SetAllInputControlsClassName(ctl, className, focusClassName);
			}
		}

		#region Web Form Designer generated code
		override protected void OnInit(EventArgs e)
		{
			//
			// CODEGEN: This call is required by the ASP.NET Web Form Designer.
			//
			InitializeComponent();
			base.OnInit(e);
		}
		
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{    
			this.Load += new System.EventHandler(this.Page_Load);

		}
		#endregion
	}
}
